-- Lookup tabel 2d
-- Gabriel Lopes
-- gabriel18.lopes@gmail.com

library ieee;
use ieee.std_logic_1164.all;
--use ieee.numeric_std.all;
use ieee.std_logic_arith.all;
use ieee.std_logic_unsigned.all;

entity LUT2d is
	port(
		n			: in 	std_logic_vector(3 downto 0);
    s			: in 	std_logic_vector(3 downto 0);
		result1	: out 	std_logic_vector(6 downto 0);
    result2 : out 	std_logic_vector(6 downto 0)
		);
end entity;

architecture behaviour of LUT2d is

  -- 64 is the biggest number that this lut have to support 2^7
  type look_up_table is array(0 to 15, 0 to 15) of std_logic_vector(6 downto 0);
  signal lut1 : look_up_table;
  signal lut2 : look_up_table;

  begin
		lut1(0,0)<= (others => '0');
	lut1(0,1) <= 7D"8";
	lut1(0,2) <= 7D"12";
	lut1(0,3) <= 7D"16";
	lut1(0,4) <= 7D"20";
	lut1(0,5) <= 7D"24";
	lut1(0,6) <= 7D"28";
	lut1(0,7) <= 7D"32";
	lut1(0,8) <= 7D"36";
	lut1(0,9) <= 7D"40";
	lut1(0,10) <= 7D"44";
	lut1(0,11) <= 7D"48";
	lut1(0,12) <= 7D"52";
	lut1(0,13) <= 7D"56";
	lut1(0,14) <= 7D"60";
	lut1(0,15) <= 7D"64";
	lut1(1,0)<= (others => '0');
	lut1(1,1)<= (others => '0');
	lut1(1,2) <= 7D"8";
	lut1(1,3) <= 7D"12";
	lut1(1,4) <= 7D"16";
	lut1(1,5) <= 7D"20";
	lut1(1,6) <= 7D"24";
	lut1(1,7) <= 7D"28";
	lut1(1,8) <= 7D"32";
	lut1(1,9) <= 7D"36";
	lut1(1,10) <= 7D"40";
	lut1(1,11) <= 7D"44";
	lut1(1,12) <= 7D"48";
	lut1(1,13) <= 7D"52";
	lut1(1,14) <= 7D"56";
	lut1(1,15) <= 7D"60";
	lut1(2,0)<= (others => '0');
	lut1(2,1)<= (others => '0');
	lut1(2,2)<= (others => '0');
	lut1(2,3) <= 7D"8";
	lut1(2,4) <= 7D"12";
	lut1(2,5) <= 7D"16";
	lut1(2,6) <= 7D"20";
	lut1(2,7) <= 7D"24";
	lut1(2,8) <= 7D"28";
	lut1(2,9) <= 7D"32";
	lut1(2,10) <= 7D"36";
	lut1(2,11) <= 7D"40";
	lut1(2,12) <= 7D"44";
	lut1(2,13) <= 7D"48";
	lut1(2,14) <= 7D"52";
	lut1(2,15) <= 7D"56";
	lut1(3,0)<= (others => '0');
	lut1(3,1)<= (others => '0');
	lut1(3,2)<= (others => '0');
	lut1(3,3)<= (others => '0');
	lut1(3,4) <= 7D"8";
	lut1(3,5) <= 7D"12";
	lut1(3,6) <= 7D"16";
	lut1(3,7) <= 7D"20";
	lut1(3,8) <= 7D"24";
	lut1(3,9) <= 7D"28";
	lut1(3,10) <= 7D"32";
	lut1(3,11) <= 7D"36";
	lut1(3,12) <= 7D"40";
	lut1(3,13) <= 7D"44";
	lut1(3,14) <= 7D"48";
	lut1(3,15) <= 7D"52";
	lut1(4,0)<= (others => '0');
	lut1(4,1)<= (others => '0');
	lut1(4,2)<= (others => '0');
	lut1(4,3)<= (others => '0');
	lut1(4,4)<= (others => '0');
	lut1(4,5) <= 7D"8";
	lut1(4,6) <= 7D"12";
	lut1(4,7) <= 7D"16";
	lut1(4,8) <= 7D"20";
	lut1(4,9) <= 7D"24";
	lut1(4,10) <= 7D"28";
	lut1(4,11) <= 7D"32";
	lut1(4,12) <= 7D"36";
	lut1(4,13) <= 7D"40";
	lut1(4,14) <= 7D"44";
	lut1(4,15) <= 7D"48";
	lut1(5,0)<= (others => '0');
	lut1(5,1)<= (others => '0');
	lut1(5,2)<= (others => '0');
	lut1(5,3)<= (others => '0');
	lut1(5,4)<= (others => '0');
	lut1(5,5)<= (others => '0');
	lut1(5,6) <= 7D"8";
	lut1(5,7) <= 7D"12";
	lut1(5,8) <= 7D"16";
	lut1(5,9) <= 7D"20";
	lut1(5,10) <= 7D"24";
	lut1(5,11) <= 7D"28";
	lut1(5,12) <= 7D"32";
	lut1(5,13) <= 7D"36";
	lut1(5,14) <= 7D"40";
	lut1(5,15) <= 7D"44";
	lut1(6,0)<= (others => '0');
	lut1(6,1)<= (others => '0');
	lut1(6,2)<= (others => '0');
	lut1(6,3)<= (others => '0');
	lut1(6,4)<= (others => '0');
	lut1(6,5)<= (others => '0');
	lut1(6,6)<= (others => '0');
	lut1(6,7) <= 7D"8";
	lut1(6,8) <= 7D"12";
	lut1(6,9) <= 7D"16";
	lut1(6,10) <= 7D"20";
	lut1(6,11) <= 7D"24";
	lut1(6,12) <= 7D"28";
	lut1(6,13) <= 7D"32";
	lut1(6,14) <= 7D"36";
	lut1(6,15) <= 7D"40";
	lut1(7,0)<= (others => '0');
	lut1(7,1)<= (others => '0');
	lut1(7,2)<= (others => '0');
	lut1(7,3)<= (others => '0');
	lut1(7,4)<= (others => '0');
	lut1(7,5)<= (others => '0');
	lut1(7,6)<= (others => '0');
	lut1(7,7)<= (others => '0');
	lut1(7,8) <= 7D"8";
	lut1(7,9) <= 7D"12";
	lut1(7,10) <= 7D"16";
	lut1(7,11) <= 7D"20";
	lut1(7,12) <= 7D"24";
	lut1(7,13) <= 7D"28";
	lut1(7,14) <= 7D"32";
	lut1(7,15) <= 7D"36";
	lut1(8,0)<= (others => '0');
	lut1(8,1)<= (others => '0');
	lut1(8,2)<= (others => '0');
	lut1(8,3)<= (others => '0');
	lut1(8,4)<= (others => '0');
	lut1(8,5)<= (others => '0');
	lut1(8,6)<= (others => '0');
	lut1(8,7)<= (others => '0');
	lut1(8,8)<= (others => '0');
	lut1(8,9) <= 7D"8";
	lut1(8,10) <= 7D"12";
	lut1(8,11) <= 7D"16";
	lut1(8,12) <= 7D"20";
	lut1(8,13) <= 7D"24";
	lut1(8,14) <= 7D"28";
	lut1(8,15) <= 7D"32";
	lut1(9,0)<= (others => '0');
	lut1(9,1)<= (others => '0');
	lut1(9,2)<= (others => '0');
	lut1(9,3)<= (others => '0');
	lut1(9,4)<= (others => '0');
	lut1(9,5)<= (others => '0');
	lut1(9,6)<= (others => '0');
	lut1(9,7)<= (others => '0');
	lut1(9,8)<= (others => '0');
	lut1(9,9)<= (others => '0');
	lut1(9,10) <= 7D"8";
	lut1(9,11) <= 7D"12";
	lut1(9,12) <= 7D"16";
	lut1(9,13) <= 7D"20";
	lut1(9,14) <= 7D"24";
	lut1(9,15) <= 7D"28";
	lut1(10,0)<= (others => '0');
	lut1(10,1)<= (others => '0');
	lut1(10,2)<= (others => '0');
	lut1(10,3)<= (others => '0');
	lut1(10,4)<= (others => '0');
	lut1(10,5)<= (others => '0');
	lut1(10,6)<= (others => '0');
	lut1(10,7)<= (others => '0');
	lut1(10,8)<= (others => '0');
	lut1(10,9)<= (others => '0');
	lut1(10,10)<= (others => '0');
	lut1(10,11) <= 7D"8";
	lut1(10,12) <= 7D"12";
	lut1(10,13) <= 7D"16";
	lut1(10,14) <= 7D"20";
	lut1(10,15) <= 7D"24";
	lut1(11,0)<= (others => '0');
	lut1(11,1)<= (others => '0');
	lut1(11,2)<= (others => '0');
	lut1(11,3)<= (others => '0');
	lut1(11,4)<= (others => '0');
	lut1(11,5)<= (others => '0');
	lut1(11,6)<= (others => '0');
	lut1(11,7)<= (others => '0');
	lut1(11,8)<= (others => '0');
	lut1(11,9)<= (others => '0');
	lut1(11,10)<= (others => '0');
	lut1(11,11)<= (others => '0');
	lut1(11,12) <= 7D"8";
	lut1(11,13) <= 7D"12";
	lut1(11,14) <= 7D"16";
	lut1(11,15) <= 7D"20";
	lut1(12,0)<= (others => '0');
	lut1(12,1)<= (others => '0');
	lut1(12,2)<= (others => '0');
	lut1(12,3)<= (others => '0');
	lut1(12,4)<= (others => '0');
	lut1(12,5)<= (others => '0');
	lut1(12,6)<= (others => '0');
	lut1(12,7)<= (others => '0');
	lut1(12,8)<= (others => '0');
	lut1(12,9)<= (others => '0');
	lut1(12,10)<= (others => '0');
	lut1(12,11)<= (others => '0');
	lut1(12,12)<= (others => '0');
	lut1(12,13) <= 7D"8";
	lut1(12,14) <= 7D"12";
	lut1(12,15) <= 7D"16";
	lut1(13,0)<= (others => '0');
	lut1(13,1)<= (others => '0');
	lut1(13,2)<= (others => '0');
	lut1(13,3)<= (others => '0');
	lut1(13,4)<= (others => '0');
	lut1(13,5)<= (others => '0');
	lut1(13,6)<= (others => '0');
	lut1(13,7)<= (others => '0');
	lut1(13,8)<= (others => '0');
	lut1(13,9)<= (others => '0');
	lut1(13,10)<= (others => '0');
	lut1(13,11)<= (others => '0');
	lut1(13,12)<= (others => '0');
	lut1(13,13)<= (others => '0');
	lut1(13,14) <= 7D"8";
	lut1(13,15) <= 7D"12";
	lut1(14,0)<= (others => '0');
	lut1(14,1)<= (others => '0');
	lut1(14,2)<= (others => '0');
	lut1(14,3)<= (others => '0');
	lut1(14,4)<= (others => '0');
	lut1(14,5)<= (others => '0');
	lut1(14,6)<= (others => '0');
	lut1(14,7)<= (others => '0');
	lut1(14,8)<= (others => '0');
	lut1(14,9)<= (others => '0');
	lut1(14,10)<= (others => '0');
	lut1(14,11)<= (others => '0');
	lut1(14,12)<= (others => '0');
	lut1(14,13)<= (others => '0');
	lut1(14,14)<= (others => '0');
	lut1(14,15) <= 7D"8";
	lut1(15,0)<= (others => '0');
	lut1(15,1)<= (others => '0');
	lut1(15,2)<= (others => '0');
	lut1(15,3)<= (others => '0');
	lut1(15,4)<= (others => '0');
	lut1(15,5)<= (others => '0');
	lut1(15,6)<= (others => '0');
	lut1(15,7)<= (others => '0');
	lut1(15,8)<= (others => '0');
	lut1(15,9)<= (others => '0');
	lut1(15,10)<= (others => '0');
	lut1(15,11)<= (others => '0');
	lut1(15,12)<= (others => '0');
	lut1(15,13)<= (others => '0');
	lut1(15,14)<= (others => '0');
	lut1(15,15)<= (others => '0');

	lut2(0,0) <= (others => '0');
	lut2(0,1) <= 7D"4";
	lut2(0,2) <= 7D"8";
	lut2(0,3) <= 7D"12";
	lut2(0,4) <= 7D"16";
	lut2(0,5) <= 7D"20";
	lut2(0,6) <= 7D"24";
	lut2(0,7) <= 7D"28";
	lut2(0,8) <= 7D"32";
	lut2(0,9) <= 7D"36";
	lut2(0,10) <= 7D"40";
	lut2(0,11) <= 7D"44";
	lut2(0,12) <= 7D"48";
	lut2(0,13) <= 7D"52";
	lut2(0,14) <= 7D"56";
	lut2(0,15) <= 7D"60";
	lut2(1,0) <= (others => '0');
	lut2(1,1) <= (others => '0');
	lut2(1,2) <= 7D"4";
	lut2(1,3) <= 7D"8";
	lut2(1,4) <= 7D"12";
	lut2(1,5) <= 7D"16";
	lut2(1,6) <= 7D"20";
	lut2(1,7) <= 7D"24";
	lut2(1,8) <= 7D"28";
	lut2(1,9) <= 7D"32";
	lut2(1,10) <= 7D"36";
	lut2(1,11) <= 7D"40";
	lut2(1,12) <= 7D"44";
	lut2(1,13) <= 7D"48";
	lut2(1,14) <= 7D"52";
	lut2(1,15) <= 7D"56";
	lut2(2,0) <= (others => '0');
	lut2(2,1) <= (others => '0');
	lut2(2,2) <= (others => '0');
	lut2(2,3) <= 7D"4";
	lut2(2,4) <= 7D"8";
	lut2(2,5) <= 7D"12";
	lut2(2,6) <= 7D"16";
	lut2(2,7) <= 7D"20";
	lut2(2,8) <= 7D"24";
	lut2(2,9) <= 7D"28";
	lut2(2,10) <= 7D"32";
	lut2(2,11) <= 7D"36";
	lut2(2,12) <= 7D"40";
	lut2(2,13) <= 7D"44";
	lut2(2,14) <= 7D"48";
	lut2(2,15) <= 7D"52";
	lut2(3,0) <= (others => '0');
	lut2(3,1) <= (others => '0');
	lut2(3,2) <= (others => '0');
	lut2(3,3) <= (others => '0');
	lut2(3,4) <= 7D"4";
	lut2(3,5) <= 7D"8";
	lut2(3,6) <= 7D"12";
	lut2(3,7) <= 7D"16";
	lut2(3,8) <= 7D"20";
	lut2(3,9) <= 7D"24";
	lut2(3,10) <= 7D"28";
	lut2(3,11) <= 7D"32";
	lut2(3,12) <= 7D"36";
	lut2(3,13) <= 7D"40";
	lut2(3,14) <= 7D"44";
	lut2(3,15) <= 7D"48";
	lut2(4,0) <= (others => '0');
	lut2(4,1) <= (others => '0');
	lut2(4,2) <= (others => '0');
	lut2(4,3) <= (others => '0');
	lut2(4,4) <= (others => '0');
	lut2(4,5) <= 7D"4";
	lut2(4,6) <= 7D"8";
	lut2(4,7) <= 7D"12";
	lut2(4,8) <= 7D"16";
	lut2(4,9) <= 7D"20";
	lut2(4,10) <= 7D"24";
	lut2(4,11) <= 7D"28";
	lut2(4,12) <= 7D"32";
	lut2(4,13) <= 7D"36";
	lut2(4,14) <= 7D"40";
	lut2(4,15) <= 7D"44";
	lut2(5,0) <= (others => '0');
	lut2(5,1) <= (others => '0');
	lut2(5,2) <= (others => '0');
	lut2(5,3) <= (others => '0');
	lut2(5,4) <= (others => '0');
	lut2(5,5) <= (others => '0');
	lut2(5,6) <= 7D"4";
	lut2(5,7) <= 7D"8";
	lut2(5,8) <= 7D"12";
	lut2(5,9) <= 7D"16";
	lut2(5,10) <= 7D"20";
	lut2(5,11) <= 7D"24";
	lut2(5,12) <= 7D"28";
	lut2(5,13) <= 7D"32";
	lut2(5,14) <= 7D"36";
	lut2(5,15) <= 7D"40";
	lut2(6,0) <= (others => '0');
	lut2(6,1) <= (others => '0');
	lut2(6,2) <= (others => '0');
	lut2(6,3) <= (others => '0');
	lut2(6,4) <= (others => '0');
	lut2(6,5) <= (others => '0');
	lut2(6,6) <= (others => '0');
	lut2(6,7) <= 7D"4";
	lut2(6,8) <= 7D"8";
	lut2(6,9) <= 7D"12";
	lut2(6,10) <= 7D"16";
	lut2(6,11) <= 7D"20";
	lut2(6,12) <= 7D"24";
	lut2(6,13) <= 7D"28";
	lut2(6,14) <= 7D"32";
	lut2(6,15) <= 7D"36";
	lut2(7,0) <= (others => '0');
	lut2(7,1) <= (others => '0');
	lut2(7,2) <= (others => '0');
	lut2(7,3) <= (others => '0');
	lut2(7,4) <= (others => '0');
	lut2(7,5) <= (others => '0');
	lut2(7,6) <= (others => '0');
	lut2(7,7) <= (others => '0');
	lut2(7,8) <= 7D"4";
	lut2(7,9) <= 7D"8";
	lut2(7,10) <= 7D"12";
	lut2(7,11) <= 7D"16";
	lut2(7,12) <= 7D"20";
	lut2(7,13) <= 7D"24";
	lut2(7,14) <= 7D"28";
	lut2(7,15) <= 7D"32";
	lut2(8,0) <= (others => '0');
	lut2(8,1) <= (others => '0');
	lut2(8,2) <= (others => '0');
	lut2(8,3) <= (others => '0');
	lut2(8,4) <= (others => '0');
	lut2(8,5) <= (others => '0');
	lut2(8,6) <= (others => '0');
	lut2(8,7) <= (others => '0');
	lut2(8,8) <= (others => '0');
	lut2(8,9) <= 7D"4";
	lut2(8,10) <= 7D"8";
	lut2(8,11) <= 7D"12";
	lut2(8,12) <= 7D"16";
	lut2(8,13) <= 7D"20";
	lut2(8,14) <= 7D"24";
	lut2(8,15) <= 7D"28";
	lut2(9,0) <= (others => '0');
	lut2(9,1) <= (others => '0');
	lut2(9,2) <= (others => '0');
	lut2(9,3) <= (others => '0');
	lut2(9,4) <= (others => '0');
	lut2(9,5) <= (others => '0');
	lut2(9,6) <= (others => '0');
	lut2(9,7) <= (others => '0');
	lut2(9,8) <= (others => '0');
	lut2(9,9) <= (others => '0');
	lut2(9,10) <= 7D"4";
	lut2(9,11) <= 7D"8";
	lut2(9,12) <= 7D"12";
	lut2(9,13) <= 7D"16";
	lut2(9,14) <= 7D"20";
	lut2(9,15) <= 7D"24";
	lut2(10,0) <= (others => '0');
	lut2(10,1) <= (others => '0');
	lut2(10,2) <= (others => '0');
	lut2(10,3) <= (others => '0');
	lut2(10,4) <= (others => '0');
	lut2(10,5) <= (others => '0');
	lut2(10,6) <= (others => '0');
	lut2(10,7) <= (others => '0');
	lut2(10,8) <= (others => '0');
	lut2(10,9) <= (others => '0');
	lut2(10,10) <= (others => '0');
	lut2(10,11) <= 7D"4";
	lut2(10,12) <= 7D"8";
	lut2(10,13) <= 7D"12";
	lut2(10,14) <= 7D"16";
	lut2(10,15) <= 7D"20";
	lut2(11,0) <= (others => '0');
	lut2(11,1) <= (others => '0');
	lut2(11,2) <= (others => '0');
	lut2(11,3) <= (others => '0');
	lut2(11,4) <= (others => '0');
	lut2(11,5) <= (others => '0');
	lut2(11,6) <= (others => '0');
	lut2(11,7) <= (others => '0');
	lut2(11,8) <= (others => '0');
	lut2(11,9) <= (others => '0');
	lut2(11,10) <= (others => '0');
	lut2(11,11) <= (others => '0');
	lut2(11,12) <= 7D"4";
	lut2(11,13) <= 7D"8";
	lut2(11,14) <= 7D"12";
	lut2(11,15) <= 7D"16";
	lut2(12,0) <= (others => '0');
	lut2(12,1) <= (others => '0');
	lut2(12,2) <= (others => '0');
	lut2(12,3) <= (others => '0');
	lut2(12,4) <= (others => '0');
	lut2(12,5) <= (others => '0');
	lut2(12,6) <= (others => '0');
	lut2(12,7) <= (others => '0');
	lut2(12,8) <= (others => '0');
	lut2(12,9) <= (others => '0');
	lut2(12,10) <= (others => '0');
	lut2(12,11) <= (others => '0');
	lut2(12,12) <= (others => '0');
	lut2(12,13) <= 7D"4";
	lut2(12,14) <= 7D"8";
	lut2(12,15) <= 7D"12";
	lut2(13,0) <= (others => '0');
	lut2(13,1) <= (others => '0');
	lut2(13,2) <= (others => '0');
	lut2(13,3) <= (others => '0');
	lut2(13,4) <= (others => '0');
	lut2(13,5) <= (others => '0');
	lut2(13,6) <= (others => '0');
	lut2(13,7) <= (others => '0');
	lut2(13,8) <= (others => '0');
	lut2(13,9) <= (others => '0');
	lut2(13,10) <= (others => '0');
	lut2(13,11) <= (others => '0');
	lut2(13,12) <= (others => '0');
	lut2(13,13) <= (others => '0');
	lut2(13,14) <= 7D"4";
	lut2(13,15) <= 7D"8";
	lut2(14,0) <= (others => '0');
	lut2(14,1) <= (others => '0');
	lut2(14,2) <= (others => '0');
	lut2(14,3) <= (others => '0');
	lut2(14,4) <= (others => '0');
	lut2(14,5) <= (others => '0');
	lut2(14,6) <= (others => '0');
	lut2(14,7) <= (others => '0');
	lut2(14,8) <= (others => '0');
	lut2(14,9) <= (others => '0');
	lut2(14,10) <= (others => '0');
	lut2(14,11) <= (others => '0');
	lut2(14,12) <= (others => '0');
	lut2(14,13) <= (others => '0');
	lut2(14,14) <= (others => '0');
	lut2(14,15) <= 7D"4";
	lut2(15,0) <= (others => '0');
	lut2(15,1) <= (others => '0');
	lut2(15,2) <= (others => '0');
	lut2(15,3) <= (others => '0');
	lut2(15,4) <= (others => '0');
	lut2(15,5) <= (others => '0');
	lut2(15,6) <= (others => '0');
	lut2(15,7) <= (others => '0');
	lut2(15,8) <= (others => '0');
	lut2(15,9) <= (others => '0');
	lut2(15,10) <= (others => '0');
	lut2(15,11) <= (others => '0');
	lut2(15,12) <= (others => '0');
	lut2(15,13) <= (others => '0');
	lut2(15,14) <= (others => '0');
	lut2(15,15) <= (others => '0');

result1 <= lut1(conv_integer(s),conv_integer(n));

result2 <= lut2(conv_integer(s),conv_integer(n));

end behaviour;
